diff --git a/src/bin/pg_controldata/pg_controldata.c b/src/bin/pg_controldata/pg_controldata.c
new file mode 100644
index 2ea8931..439fcbd
*** a/src/bin/pg_controldata/pg_controldata.c
--- b/src/bin/pg_controldata/pg_controldata.c
*************** main(int argc, char *argv[])
*** 225,252 ****
  		   ControlFile->checkPointCopy.PrevTimeLineID);
  	printf(_("Latest checkpoint's full_page_writes: %s\n"),
  		   ControlFile->checkPointCopy.fullPageWrites ? _("on") : _("off"));
! 	printf(_("Latest checkpoint's NextXID:          %u:%u\n"),
! 		   ControlFile->checkPointCopy.nextXidEpoch,
  		   ControlFile->checkPointCopy.nextXid);
  	printf(_("Latest checkpoint's NextOID:          %u\n"),
  		   ControlFile->checkPointCopy.nextOid);
! 	printf(_("Latest checkpoint's NextMultiXactId:  %u\n"),
  		   ControlFile->checkPointCopy.nextMulti);
! 	printf(_("Latest checkpoint's NextMultiOffset:  %u\n"),
  		   ControlFile->checkPointCopy.nextMultiOffset);
! 	printf(_("Latest checkpoint's oldestXID:        %u\n"),
  		   ControlFile->checkPointCopy.oldestXid);
  	printf(_("Latest checkpoint's oldestXID's DB:   %u\n"),
  		   ControlFile->checkPointCopy.oldestXidDB);
! 	printf(_("Latest checkpoint's oldestActiveXID:  %u\n"),
  		   ControlFile->checkPointCopy.oldestActiveXid);
! 	printf(_("Latest checkpoint's oldestMultiXid:   %u\n"),
  		   ControlFile->checkPointCopy.oldestMulti);
  	printf(_("Latest checkpoint's oldestMulti's DB: %u\n"),
  		   ControlFile->checkPointCopy.oldestMultiDB);
! 	printf(_("Latest checkpoint's oldestCommitTsXid:%u\n"),
  		   ControlFile->checkPointCopy.oldestCommitTsXid);
! 	printf(_("Latest checkpoint's newestCommitTsXid:%u\n"),
  		   ControlFile->checkPointCopy.newestCommitTsXid);
  	printf(_("Time of latest checkpoint:            %s\n"),
  		   ckpttime_str);
--- 225,251 ----
  		   ControlFile->checkPointCopy.PrevTimeLineID);
  	printf(_("Latest checkpoint's full_page_writes: %s\n"),
  		   ControlFile->checkPointCopy.fullPageWrites ? _("on") : _("off"));
! 	printf(_("Latest checkpoint's NextXID:          " XID_FMT "\n"),
  		   ControlFile->checkPointCopy.nextXid);
  	printf(_("Latest checkpoint's NextOID:          %u\n"),
  		   ControlFile->checkPointCopy.nextOid);
! 	printf(_("Latest checkpoint's NextMultiXactId:  " XID_FMT "\n"),
  		   ControlFile->checkPointCopy.nextMulti);
! 	printf(_("Latest checkpoint's NextMultiOffset:  " INT64_FORMAT "\n"),
  		   ControlFile->checkPointCopy.nextMultiOffset);
! 	printf(_("Latest checkpoint's oldestXID:        " XID_FMT "\n"),
  		   ControlFile->checkPointCopy.oldestXid);
  	printf(_("Latest checkpoint's oldestXID's DB:   %u\n"),
  		   ControlFile->checkPointCopy.oldestXidDB);
! 	printf(_("Latest checkpoint's oldestActiveXID:  " XID_FMT "\n"),
  		   ControlFile->checkPointCopy.oldestActiveXid);
! 	printf(_("Latest checkpoint's oldestMultiXid:   " XID_FMT "\n"),
  		   ControlFile->checkPointCopy.oldestMulti);
  	printf(_("Latest checkpoint's oldestMulti's DB: %u\n"),
  		   ControlFile->checkPointCopy.oldestMultiDB);
! 	printf(_("Latest checkpoint's oldestCommitTsXid:" XID_FMT "\n"),
  		   ControlFile->checkPointCopy.oldestCommitTsXid);
! 	printf(_("Latest checkpoint's newestCommitTsXid:" XID_FMT "\n"),
  		   ControlFile->checkPointCopy.newestCommitTsXid);
  	printf(_("Time of latest checkpoint:            %s\n"),
  		   ckpttime_str);
diff --git a/src/bin/pg_resetwal/pg_resetwal.c b/src/bin/pg_resetwal/pg_resetwal.c
new file mode 100644
index 7f01067..dbeac26
*** a/src/bin/pg_resetwal/pg_resetwal.c
--- b/src/bin/pg_resetwal/pg_resetwal.c
*************** static ControlFileData ControlFile;		/* 
*** 61,67 ****
  static XLogSegNo newXlogSegNo;	/* new XLOG segment # */
  static bool guessed = false;	/* T if we had to guess at any values */
  static const char *progname;
- static uint32 set_xid_epoch = (uint32) -1;
  static TransactionId set_xid = 0;
  static TransactionId set_oldest_commit_ts_xid = 0;
  static TransactionId set_newest_commit_ts_xid = 0;
--- 61,66 ----
*************** static void KillExistingXLOG(void);
*** 82,87 ****
--- 81,87 ----
  static void KillExistingArchiveStatus(void);
  static void WriteEmptyXLOG(void);
  static void usage(void);
+ static uint64 str2uint64(const char *str, char **endptr, int base);
  
  
  int
*************** main(int argc, char *argv[])
*** 115,121 ****
  	}
  
  
! 	while ((c = getopt(argc, argv, "c:D:e:fl:m:no:O:x:")) != -1)
  	{
  		switch (c)
  		{
--- 115,121 ----
  	}
  
  
! 	while ((c = getopt(argc, argv, "c:D:fl:m:no:O:x:")) != -1)
  	{
  		switch (c)
  		{
*************** main(int argc, char *argv[])
*** 131,155 ****
  				noupdate = true;
  				break;
  
- 			case 'e':
- 				set_xid_epoch = strtoul(optarg, &endptr, 0);
- 				if (endptr == optarg || *endptr != '\0')
- 				{
- 					/*------
- 					  translator: the second %s is a command line argument (-e, etc) */
- 					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-e");
- 					fprintf(stderr, _("Try \"%s --help\" for more information.\n"), progname);
- 					exit(1);
- 				}
- 				if (set_xid_epoch == -1)
- 				{
- 					fprintf(stderr, _("%s: transaction ID epoch (-e) must not be -1\n"), progname);
- 					exit(1);
- 				}
- 				break;
- 
  			case 'x':
! 				set_xid = strtoul(optarg, &endptr, 0);
  				if (endptr == optarg || *endptr != '\0')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-x");
--- 131,138 ----
  				noupdate = true;
  				break;
  
  			case 'x':
! 				set_xid = str2uint64(optarg, &endptr, 0);
  				if (endptr == optarg || *endptr != '\0')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-x");
*************** main(int argc, char *argv[])
*** 164,177 ****
  				break;
  
  			case 'c':
! 				set_oldest_commit_ts_xid = strtoul(optarg, &endptr, 0);
  				if (endptr == optarg || *endptr != ',')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-c");
  					fprintf(stderr, _("Try \"%s --help\" for more information.\n"), progname);
  					exit(1);
  				}
! 				set_newest_commit_ts_xid = strtoul(endptr + 1, &endptr2, 0);
  				if (endptr2 == endptr + 1 || *endptr2 != '\0')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-c");
--- 147,160 ----
  				break;
  
  			case 'c':
! 				set_oldest_commit_ts_xid = str2uint64(optarg, &endptr, 0);
  				if (endptr == optarg || *endptr != ',')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-c");
  					fprintf(stderr, _("Try \"%s --help\" for more information.\n"), progname);
  					exit(1);
  				}
! 				set_newest_commit_ts_xid = str2uint64(endptr + 1, &endptr2, 0);
  				if (endptr2 == endptr + 1 || *endptr2 != '\0')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-c");
*************** main(int argc, char *argv[])
*** 210,216 ****
  				break;
  
  			case 'm':
! 				set_mxid = strtoul(optarg, &endptr, 0);
  				if (endptr == optarg || *endptr != ',')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-m");
--- 193,199 ----
  				break;
  
  			case 'm':
! 				set_mxid = str2uint64(optarg, &endptr, 0);
  				if (endptr == optarg || *endptr != ',')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-m");
*************** main(int argc, char *argv[])
*** 218,224 ****
  					exit(1);
  				}
  
! 				set_oldestmxid = strtoul(endptr + 1, &endptr2, 0);
  				if (endptr2 == endptr + 1 || *endptr2 != '\0')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-m");
--- 201,207 ----
  					exit(1);
  				}
  
! 				set_oldestmxid = str2uint64(endptr + 1, &endptr2, 0);
  				if (endptr2 == endptr + 1 || *endptr2 != '\0')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-m");
*************** main(int argc, char *argv[])
*** 244,250 ****
  				break;
  
  			case 'O':
! 				set_mxoff = strtoul(optarg, &endptr, 0);
  				if (endptr == optarg || *endptr != '\0')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-O");
--- 227,233 ----
  				break;
  
  			case 'O':
! 				set_mxoff = str2uint64(optarg, &endptr, 0);
  				if (endptr == optarg || *endptr != '\0')
  				{
  					fprintf(stderr, _("%s: invalid argument for option %s\n"), progname, "-O");
*************** main(int argc, char *argv[])
*** 362,374 ****
  	if ((guessed && !force) || noupdate)
  		PrintControlValues(guessed);
  
- 	/*
- 	 * Adjust fields if required by switches.  (Do this now so that printout,
- 	 * if any, includes these values.)
- 	 */
- 	if (set_xid_epoch != -1)
- 		ControlFile.checkPointCopy.nextXidEpoch = set_xid_epoch;
- 
  	if (set_xid != 0)
  	{
  		ControlFile.checkPointCopy.nextXid = set_xid;
--- 345,350 ----
*************** GuessControlValues(void)
*** 628,634 ****
  	ControlFile.checkPointCopy.ThisTimeLineID = 1;
  	ControlFile.checkPointCopy.PrevTimeLineID = 1;
  	ControlFile.checkPointCopy.fullPageWrites = false;
- 	ControlFile.checkPointCopy.nextXidEpoch = 0;
  	ControlFile.checkPointCopy.nextXid = FirstNormalTransactionId;
  	ControlFile.checkPointCopy.nextOid = FirstBootstrapObjectId;
  	ControlFile.checkPointCopy.nextMulti = FirstMultiXactId;
--- 604,609 ----
*************** PrintControlValues(bool guessed)
*** 708,735 ****
  		   ControlFile.checkPointCopy.ThisTimeLineID);
  	printf(_("Latest checkpoint's full_page_writes: %s\n"),
  		   ControlFile.checkPointCopy.fullPageWrites ? _("on") : _("off"));
! 	printf(_("Latest checkpoint's NextXID:          %u:%u\n"),
! 		   ControlFile.checkPointCopy.nextXidEpoch,
  		   ControlFile.checkPointCopy.nextXid);
  	printf(_("Latest checkpoint's NextOID:          %u\n"),
  		   ControlFile.checkPointCopy.nextOid);
! 	printf(_("Latest checkpoint's NextMultiXactId:  %u\n"),
  		   ControlFile.checkPointCopy.nextMulti);
! 	printf(_("Latest checkpoint's NextMultiOffset:  %u\n"),
  		   ControlFile.checkPointCopy.nextMultiOffset);
! 	printf(_("Latest checkpoint's oldestXID:        %u\n"),
  		   ControlFile.checkPointCopy.oldestXid);
  	printf(_("Latest checkpoint's oldestXID's DB:   %u\n"),
  		   ControlFile.checkPointCopy.oldestXidDB);
! 	printf(_("Latest checkpoint's oldestActiveXID:  %u\n"),
  		   ControlFile.checkPointCopy.oldestActiveXid);
! 	printf(_("Latest checkpoint's oldestMultiXid:   %u\n"),
  		   ControlFile.checkPointCopy.oldestMulti);
  	printf(_("Latest checkpoint's oldestMulti's DB: %u\n"),
  		   ControlFile.checkPointCopy.oldestMultiDB);
! 	printf(_("Latest checkpoint's oldestCommitTsXid:%u\n"),
  		   ControlFile.checkPointCopy.oldestCommitTsXid);
! 	printf(_("Latest checkpoint's newestCommitTsXid:%u\n"),
  		   ControlFile.checkPointCopy.newestCommitTsXid);
  	printf(_("Maximum data alignment:               %u\n"),
  		   ControlFile.maxAlign);
--- 683,709 ----
  		   ControlFile.checkPointCopy.ThisTimeLineID);
  	printf(_("Latest checkpoint's full_page_writes: %s\n"),
  		   ControlFile.checkPointCopy.fullPageWrites ? _("on") : _("off"));
! 	printf(_("Latest checkpoint's NextXID:          " XID_FMT "\n"),
  		   ControlFile.checkPointCopy.nextXid);
  	printf(_("Latest checkpoint's NextOID:          %u\n"),
  		   ControlFile.checkPointCopy.nextOid);
! 	printf(_("Latest checkpoint's NextMultiXactId:  " XID_FMT "\n"),
  		   ControlFile.checkPointCopy.nextMulti);
! 	printf(_("Latest checkpoint's NextMultiOffset:  " INT64_FORMAT "\n"),
  		   ControlFile.checkPointCopy.nextMultiOffset);
! 	printf(_("Latest checkpoint's oldestXID:        " XID_FMT "\n"),
  		   ControlFile.checkPointCopy.oldestXid);
  	printf(_("Latest checkpoint's oldestXID's DB:   %u\n"),
  		   ControlFile.checkPointCopy.oldestXidDB);
! 	printf(_("Latest checkpoint's oldestActiveXID:  " XID_FMT "\n"),
  		   ControlFile.checkPointCopy.oldestActiveXid);
! 	printf(_("Latest checkpoint's oldestMultiXid:   " XID_FMT "\n"),
  		   ControlFile.checkPointCopy.oldestMulti);
  	printf(_("Latest checkpoint's oldestMulti's DB: %u\n"),
  		   ControlFile.checkPointCopy.oldestMultiDB);
! 	printf(_("Latest checkpoint's oldestCommitTsXid:" XID_FMT "\n"),
  		   ControlFile.checkPointCopy.oldestCommitTsXid);
! 	printf(_("Latest checkpoint's newestCommitTsXid:" XID_FMT "\n"),
  		   ControlFile.checkPointCopy.newestCommitTsXid);
  	printf(_("Maximum data alignment:               %u\n"),
  		   ControlFile.maxAlign);
*************** PrintNewControlValues(void)
*** 778,786 ****
  
  	if (set_mxid != 0)
  	{
! 		printf(_("NextMultiXactId:                      %u\n"),
  			   ControlFile.checkPointCopy.nextMulti);
! 		printf(_("OldestMultiXid:                       %u\n"),
  			   ControlFile.checkPointCopy.oldestMulti);
  		printf(_("OldestMulti's DB:                     %u\n"),
  			   ControlFile.checkPointCopy.oldestMultiDB);
--- 752,760 ----
  
  	if (set_mxid != 0)
  	{
! 		printf(_("NextMultiXactId:                      " XID_FMT "\n"),
  			   ControlFile.checkPointCopy.nextMulti);
! 		printf(_("OldestMultiXid:                       " XID_FMT "\n"),
  			   ControlFile.checkPointCopy.oldestMulti);
  		printf(_("OldestMulti's DB:                     %u\n"),
  			   ControlFile.checkPointCopy.oldestMultiDB);
*************** PrintNewControlValues(void)
*** 788,794 ****
  
  	if (set_mxoff != -1)
  	{
! 		printf(_("NextMultiOffset:                      %u\n"),
  			   ControlFile.checkPointCopy.nextMultiOffset);
  	}
  
--- 762,768 ----
  
  	if (set_mxoff != -1)
  	{
! 		printf(_("NextMultiOffset:                      " INT64_FORMAT "\n"),
  			   ControlFile.checkPointCopy.nextMultiOffset);
  	}
  
*************** PrintNewControlValues(void)
*** 800,827 ****
  
  	if (set_xid != 0)
  	{
! 		printf(_("NextXID:                              %u\n"),
  			   ControlFile.checkPointCopy.nextXid);
! 		printf(_("OldestXID:                            %u\n"),
  			   ControlFile.checkPointCopy.oldestXid);
  		printf(_("OldestXID's DB:                       %u\n"),
  			   ControlFile.checkPointCopy.oldestXidDB);
  	}
  
- 	if (set_xid_epoch != -1)
- 	{
- 		printf(_("NextXID epoch:                        %u\n"),
- 			   ControlFile.checkPointCopy.nextXidEpoch);
- 	}
- 
  	if (set_oldest_commit_ts_xid != 0)
  	{
! 		printf(_("oldestCommitTsXid:                    %u\n"),
  			   ControlFile.checkPointCopy.oldestCommitTsXid);
  	}
  	if (set_newest_commit_ts_xid != 0)
  	{
! 		printf(_("newestCommitTsXid:                    %u\n"),
  			   ControlFile.checkPointCopy.newestCommitTsXid);
  	}
  }
--- 774,795 ----
  
  	if (set_xid != 0)
  	{
! 		printf(_("NextXID:                              " XID_FMT "\n"),
  			   ControlFile.checkPointCopy.nextXid);
! 		printf(_("OldestXID:                            " XID_FMT "\n"),
  			   ControlFile.checkPointCopy.oldestXid);
  		printf(_("OldestXID's DB:                       %u\n"),
  			   ControlFile.checkPointCopy.oldestXidDB);
  	}
  
  	if (set_oldest_commit_ts_xid != 0)
  	{
! 		printf(_("oldestCommitTsXid:                    " XID_FMT "\n"),
  			   ControlFile.checkPointCopy.oldestCommitTsXid);
  	}
  	if (set_newest_commit_ts_xid != 0)
  	{
! 		printf(_("newestCommitTsXid:                    " XID_FMT "\n"),
  			   ControlFile.checkPointCopy.newestCommitTsXid);
  	}
  }
*************** usage(void)
*** 1233,1239 ****
  	printf(_("  -c XID,XID       set oldest and newest transactions bearing commit timestamp\n"));
  	printf(_("                   (zero in either value means no change)\n"));
  	printf(_(" [-D] DATADIR      data directory\n"));
- 	printf(_("  -e XIDEPOCH      set next transaction ID epoch\n"));
  	printf(_("  -f               force update to be done\n"));
  	printf(_("  -l WALFILE       force minimum WAL starting location for new write-ahead log\n"));
  	printf(_("  -m MXID,MXID     set next and oldest multitransaction ID\n"));
--- 1201,1206 ----
*************** usage(void)
*** 1245,1247 ****
--- 1212,1232 ----
  	printf(_("  -?, --help       show this help, then exit\n"));
  	printf(_("\nReport bugs to <pgsql-bugs@postgresql.org>.\n"));
  }
+ 
+ 
+ /*
+  *	str2uint64()
+  *
+  *	convert string to 64-bit unsigned int
+  */
+ static uint64
+ str2uint64(const char *str, char **endptr, int base)
+ {
+ #ifdef _MSC_VER					/* MSVC only */
+ 	return _strtoui64(str, endptr, base);
+ #elif defined(HAVE_STRTOULL) && SIZEOF_LONG < 8
+ 	return strtoull(str, endptr, base);
+ #else
+ 	return strtoul(str, endptr, base);
+ #endif
+ }
diff --git a/src/bin/pg_upgrade/controldata.c b/src/bin/pg_upgrade/controldata.c
new file mode 100644
index 5192568..83cc0d6
*** a/src/bin/pg_upgrade/controldata.c
--- b/src/bin/pg_upgrade/controldata.c
*************** get_control_data(ClusterInfo *cluster, b
*** 201,226 ****
  				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
  
  			p++;				/* remove ':' char */
! 			cluster->controldata.chkpnt_nxtepoch = str2uint(p);
! 
! 			/*
! 			 * Delimiter changed from '/' to ':' in 9.6.  We don't test for
! 			 * the catalog version of the change because the catalog version
! 			 * is pulled from pg_controldata too, and it isn't worth adding an
! 			 * order dependency for this --- we just check the string.
! 			 */
! 			if (strchr(p, '/') != NULL)
! 				p = strchr(p, '/');
! 			else if (GET_MAJOR_VERSION(cluster->major_version) >= 906)
! 				p = strchr(p, ':');
! 			else
! 				p = NULL;
! 
! 			if (p == NULL || strlen(p) <= 1)
! 				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
! 
! 			p++;				/* remove '/' or ':' char */
! 			cluster->controldata.chkpnt_nxtxid = str2uint(p);
  			got_xid = true;
  		}
  		else if ((p = strstr(bufin, "Latest checkpoint's NextOID:")) != NULL)
--- 201,207 ----
  				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
  
  			p++;				/* remove ':' char */
! 			cluster->controldata.chkpnt_nxtxid = str2uint64(p);
  			got_xid = true;
  		}
  		else if ((p = strstr(bufin, "Latest checkpoint's NextOID:")) != NULL)
*************** get_control_data(ClusterInfo *cluster, b
*** 242,248 ****
  				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
  
  			p++;				/* remove ':' char */
! 			cluster->controldata.chkpnt_nxtmulti = str2uint(p);
  			got_multi = true;
  		}
  		else if ((p = strstr(bufin, "Latest checkpoint's oldestMultiXid:")) != NULL)
--- 223,229 ----
  				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
  
  			p++;				/* remove ':' char */
! 			cluster->controldata.chkpnt_nxtmulti = str2uint64(p);
  			got_multi = true;
  		}
  		else if ((p = strstr(bufin, "Latest checkpoint's oldestMultiXid:")) != NULL)
*************** get_control_data(ClusterInfo *cluster, b
*** 253,259 ****
  				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
  
  			p++;				/* remove ':' char */
! 			cluster->controldata.chkpnt_oldstMulti = str2uint(p);
  			got_oldestmulti = true;
  		}
  		else if ((p = strstr(bufin, "Latest checkpoint's NextMultiOffset:")) != NULL)
--- 234,240 ----
  				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
  
  			p++;				/* remove ':' char */
! 			cluster->controldata.chkpnt_oldstMulti = str2uint64(p);
  			got_oldestmulti = true;
  		}
  		else if ((p = strstr(bufin, "Latest checkpoint's NextMultiOffset:")) != NULL)
*************** get_control_data(ClusterInfo *cluster, b
*** 264,270 ****
  				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
  
  			p++;				/* remove ':' char */
! 			cluster->controldata.chkpnt_nxtmxoff = str2uint(p);
  			got_mxoff = true;
  		}
  		else if ((p = strstr(bufin, "First log segment after reset:")) != NULL)
--- 245,251 ----
  				pg_fatal("%d: controldata retrieval problem\n", __LINE__);
  
  			p++;				/* remove ':' char */
! 			cluster->controldata.chkpnt_nxtmxoff = str2uint64(p);
  			got_mxoff = true;
  		}
  		else if ((p = strstr(bufin, "First log segment after reset:")) != NULL)
diff --git a/src/bin/pg_upgrade/pg_upgrade.c b/src/bin/pg_upgrade/pg_upgrade.c
new file mode 100644
index ca1aa5c..eaf878d
*** a/src/bin/pg_upgrade/pg_upgrade.c
--- b/src/bin/pg_upgrade/pg_upgrade.c
*************** copy_xact_xlog_xid(void)
*** 415,430 ****
  	/* set the next transaction id and epoch of the new cluster */
  	prep_status("Setting next transaction ID and epoch for new cluster");
  	exec_prog(UTILITY_LOG_FILE, NULL, true,
! 			  "\"%s/pg_resetwal\" -f -x %u \"%s\"",
  			  new_cluster.bindir, old_cluster.controldata.chkpnt_nxtxid,
  			  new_cluster.pgdata);
  	exec_prog(UTILITY_LOG_FILE, NULL, true,
  			  "\"%s/pg_resetwal\" -f -e %u \"%s\"",
  			  new_cluster.bindir, old_cluster.controldata.chkpnt_nxtepoch,
  			  new_cluster.pgdata);
  	/* must reset commit timestamp limits also */
  	exec_prog(UTILITY_LOG_FILE, NULL, true,
! 			  "\"%s/pg_resetwal\" -f -c %u,%u \"%s\"",
  			  new_cluster.bindir,
  			  old_cluster.controldata.chkpnt_nxtxid,
  			  old_cluster.controldata.chkpnt_nxtxid,
--- 415,432 ----
  	/* set the next transaction id and epoch of the new cluster */
  	prep_status("Setting next transaction ID and epoch for new cluster");
  	exec_prog(UTILITY_LOG_FILE, NULL, true,
! 			  "\"%s/pg_resetwal\" -f -x " XID_FMT " \"%s\"",
  			  new_cluster.bindir, old_cluster.controldata.chkpnt_nxtxid,
  			  new_cluster.pgdata);
+ #ifdef NOT_USED
  	exec_prog(UTILITY_LOG_FILE, NULL, true,
  			  "\"%s/pg_resetwal\" -f -e %u \"%s\"",
  			  new_cluster.bindir, old_cluster.controldata.chkpnt_nxtepoch,
  			  new_cluster.pgdata);
+ #endif
  	/* must reset commit timestamp limits also */
  	exec_prog(UTILITY_LOG_FILE, NULL, true,
! 			  "\"%s/pg_resetwal\" -f -c " XID_FMT "," XID_FMT " \"%s\"",
  			  new_cluster.bindir,
  			  old_cluster.controldata.chkpnt_nxtxid,
  			  old_cluster.controldata.chkpnt_nxtxid,
*************** copy_xact_xlog_xid(void)
*** 450,456 ****
  		 * counters here and the oldest multi present on system.
  		 */
  		exec_prog(UTILITY_LOG_FILE, NULL, true,
! 				  "\"%s/pg_resetwal\" -O %u -m %u,%u \"%s\"",
  				  new_cluster.bindir,
  				  old_cluster.controldata.chkpnt_nxtmxoff,
  				  old_cluster.controldata.chkpnt_nxtmulti,
--- 452,458 ----
  		 * counters here and the oldest multi present on system.
  		 */
  		exec_prog(UTILITY_LOG_FILE, NULL, true,
! 				  "\"%s/pg_resetwal\" -O " XID_FMT " -m " XID_FMT "," XID_FMT " \"%s\"",
  				  new_cluster.bindir,
  				  old_cluster.controldata.chkpnt_nxtmxoff,
  				  old_cluster.controldata.chkpnt_nxtmulti,
*************** copy_xact_xlog_xid(void)
*** 478,484 ****
  		 * next=MaxMultiXactId, but multixact.c can cope with that just fine.
  		 */
  		exec_prog(UTILITY_LOG_FILE, NULL, true,
! 				  "\"%s/pg_resetwal\" -m %u,%u \"%s\"",
  				  new_cluster.bindir,
  				  old_cluster.controldata.chkpnt_nxtmulti + 1,
  				  old_cluster.controldata.chkpnt_nxtmulti,
--- 480,486 ----
  		 * next=MaxMultiXactId, but multixact.c can cope with that just fine.
  		 */
  		exec_prog(UTILITY_LOG_FILE, NULL, true,
! 				  "\"%s/pg_resetwal\" -m " XID_FMT "," XID_FMT " \"%s\"",
  				  new_cluster.bindir,
  				  old_cluster.controldata.chkpnt_nxtmulti + 1,
  				  old_cluster.controldata.chkpnt_nxtmulti,
*************** set_frozenxids(bool minmxid_only)
*** 529,541 ****
  		/* set pg_database.datfrozenxid */
  		PQclear(executeQueryOrDie(conn_template1,
  								  "UPDATE pg_catalog.pg_database "
! 								  "SET	datfrozenxid = '%u'",
  								  old_cluster.controldata.chkpnt_nxtxid));
  
  	/* set pg_database.datminmxid */
  	PQclear(executeQueryOrDie(conn_template1,
  							  "UPDATE pg_catalog.pg_database "
! 							  "SET	datminmxid = '%u'",
  							  old_cluster.controldata.chkpnt_nxtmulti));
  
  	/* get database names */
--- 531,543 ----
  		/* set pg_database.datfrozenxid */
  		PQclear(executeQueryOrDie(conn_template1,
  								  "UPDATE pg_catalog.pg_database "
! 								  "SET	datfrozenxid = '" XID_FMT "'",
  								  old_cluster.controldata.chkpnt_nxtxid));
  
  	/* set pg_database.datminmxid */
  	PQclear(executeQueryOrDie(conn_template1,
  							  "UPDATE pg_catalog.pg_database "
! 							  "SET	datminmxid = '" XID_FMT "'",
  							  old_cluster.controldata.chkpnt_nxtmulti));
  
  	/* get database names */
*************** set_frozenxids(bool minmxid_only)
*** 570,576 ****
  			/* set pg_class.relfrozenxid */
  			PQclear(executeQueryOrDie(conn,
  									  "UPDATE	pg_catalog.pg_class "
! 									  "SET	relfrozenxid = '%u' "
  			/* only heap, materialized view, and TOAST are vacuumed */
  									  "WHERE	relkind IN ("
  									  CppAsString2(RELKIND_RELATION) ", "
--- 572,578 ----
  			/* set pg_class.relfrozenxid */
  			PQclear(executeQueryOrDie(conn,
  									  "UPDATE	pg_catalog.pg_class "
! 									  "SET	relfrozenxid = '" XID_FMT "' "
  			/* only heap, materialized view, and TOAST are vacuumed */
  									  "WHERE	relkind IN ("
  									  CppAsString2(RELKIND_RELATION) ", "
*************** set_frozenxids(bool minmxid_only)
*** 581,587 ****
  		/* set pg_class.relminmxid */
  		PQclear(executeQueryOrDie(conn,
  								  "UPDATE	pg_catalog.pg_class "
! 								  "SET	relminmxid = '%u' "
  		/* only heap, materialized view, and TOAST are vacuumed */
  								  "WHERE	relkind IN ("
  								  CppAsString2(RELKIND_RELATION) ", "
--- 583,589 ----
  		/* set pg_class.relminmxid */
  		PQclear(executeQueryOrDie(conn,
  								  "UPDATE	pg_catalog.pg_class "
! 								  "SET	relminmxid = '" XID_FMT "' "
  		/* only heap, materialized view, and TOAST are vacuumed */
  								  "WHERE	relkind IN ("
  								  CppAsString2(RELKIND_RELATION) ", "
diff --git a/src/bin/pg_upgrade/pg_upgrade.h b/src/bin/pg_upgrade/pg_upgrade.h
new file mode 100644
index 8fbf8ac..92e2acf
*** a/src/bin/pg_upgrade/pg_upgrade.h
--- b/src/bin/pg_upgrade/pg_upgrade.h
*************** typedef struct
*** 207,218 ****
  	uint32		ctrl_ver;
  	uint32		cat_ver;
  	char		nextxlogfile[25];
! 	uint32		chkpnt_nxtxid;
! 	uint32		chkpnt_nxtepoch;
  	uint32		chkpnt_nxtoid;
! 	uint32		chkpnt_nxtmulti;
! 	uint32		chkpnt_nxtmxoff;
! 	uint32		chkpnt_oldstMulti;
  	uint32		align;
  	uint32		blocksz;
  	uint32		largesz;
--- 207,217 ----
  	uint32		ctrl_ver;
  	uint32		cat_ver;
  	char		nextxlogfile[25];
! 	uint64		chkpnt_nxtxid;
  	uint32		chkpnt_nxtoid;
! 	uint64		chkpnt_nxtmulti;
! 	uint64		chkpnt_nxtmxoff;
! 	uint64		chkpnt_oldstMulti;
  	uint32		align;
  	uint32		blocksz;
  	uint32		largesz;
*************** void		end_progress_output(void);
*** 432,437 ****
--- 431,437 ----
  void		prep_status(const char *fmt,...) pg_attribute_printf(1, 2);
  void		check_ok(void);
  unsigned int str2uint(const char *str);
+ uint64		str2uint64(const char *str);
  void		pg_putenv(const char *var, const char *val);
  
  
diff --git a/src/bin/pg_upgrade/util.c b/src/bin/pg_upgrade/util.c
new file mode 100644
index 44c1bc8..e5d7bd3
*** a/src/bin/pg_upgrade/util.c
--- b/src/bin/pg_upgrade/util.c
*************** str2uint(const char *str)
*** 245,250 ****
--- 245,268 ----
  
  
  /*
+  *	str2uint64()
+  *
+  *	convert string to 64-bit unsigned int
+  */
+ uint64
+ str2uint64(const char *str)
+ {
+ #ifdef _MSC_VER					/* MSVC only */
+ 	return _strtoui64(str, NULL, 10);
+ #elif defined(HAVE_STRTOULL) && SIZEOF_LONG < 8
+ 	return strtoull(str, NULL, 10);
+ #else
+ 	return strtoul(str, NULL, 10);
+ #endif
+ }
+ 
+ 
+ /*
   *	pg_putenv()
   *
   *	This is like putenv(), but takes two arguments.
diff --git a/src/bin/pg_waldump/pg_waldump.c b/src/bin/pg_waldump/pg_waldump.c
new file mode 100644
index 2578d4b..0fb0f57
*** a/src/bin/pg_waldump/pg_waldump.c
--- b/src/bin/pg_waldump/pg_waldump.c
*************** XLogDumpDisplayRecord(XLogDumpConfig *co
*** 452,458 ****
  	if (id == NULL)
  		id = psprintf("UNKNOWN (%x)", info & ~XLR_INFO_MASK);
  
! 	printf("rmgr: %-11s len (rec/tot): %6u/%6u, tx: %10u, lsn: %X/%08X, prev %X/%08X, ",
  		   desc->rm_name,
  		   rec_len, XLogRecGetTotalLen(record),
  		   XLogRecGetXid(record),
--- 452,458 ----
  	if (id == NULL)
  		id = psprintf("UNKNOWN (%x)", info & ~XLR_INFO_MASK);
  
! 	printf("rmgr: %-11s len (rec/tot): %6u/%6u, tx: " XID_FMT ", lsn: %X/%08X, prev %X/%08X, ",
  		   desc->rm_name,
  		   rec_len, XLogRecGetTotalLen(record),
  		   XLogRecGetXid(record),
*************** main(int argc, char **argv)
*** 868,874 ****
  				exit(EXIT_SUCCESS);
  				break;
  			case 'x':
! 				if (sscanf(optarg, "%u", &config.filter_by_xid) != 1)
  				{
  					fprintf(stderr, _("%s: could not parse \"%s\" as a valid xid\n"),
  							progname, optarg);
--- 868,874 ----
  				exit(EXIT_SUCCESS);
  				break;
  			case 'x':
! 				if (sscanf(optarg, XID_FMT, &config.filter_by_xid) != 1)
  				{
  					fprintf(stderr, _("%s: could not parse \"%s\" as a valid xid\n"),
  							progname, optarg);
diff --git a/src/include/access/clog.h b/src/include/access/clog.h
new file mode 100644
index 5ac7cdd..e938a3d
*** a/src/include/access/clog.h
--- b/src/include/access/clog.h
*************** typedef int XidStatus;
*** 30,36 ****
  
  typedef struct xl_clog_truncate
  {
! 	int			pageno;
  	TransactionId oldestXact;
  	Oid			oldestXactDb;
  } xl_clog_truncate;
--- 30,36 ----
  
  typedef struct xl_clog_truncate
  {
! 	int64		pageno;
  	TransactionId oldestXact;
  	Oid			oldestXactDb;
  } xl_clog_truncate;
diff --git a/src/include/access/commit_ts.h b/src/include/access/commit_ts.h
new file mode 100644
index f172c91..0708d13
*** a/src/include/access/commit_ts.h
--- b/src/include/access/commit_ts.h
*************** typedef struct xl_commit_ts_set
*** 63,69 ****
  
  typedef struct xl_commit_ts_truncate
  {
! 	int			pageno;
  	TransactionId oldestXid;
  } xl_commit_ts_truncate;
  
--- 63,69 ----
  
  typedef struct xl_commit_ts_truncate
  {
! 	int64		pageno;
  	TransactionId oldestXid;
  } xl_commit_ts_truncate;
  
